"""
@file dataloader.py

Program which take a input data file, and make
the variable
"""
#import parmepy.constants import debug
from parmepy.constants import np


class DataLoader(object):
    """
    Take a data file which containt all variables of the simulation.
    and he test and load the variable into the dataloader class.
    """

#    @debug
    def __new__(cls, *args, **kw):
        return object.__new__(cls, *args, **kw)

#    @debug
    def __init__(self, filename='input.dat'):
        """
        the initialization will be ignore the line with '#' caracter

        @param filename: name of data file.
        """
        self.filename = filename
        self.varlist = []
        filestream = open(filename, 'r')
        print '=============Load=============='
        count = 0
        for line in filestream:
            if line[0] == '#' or line.find('=') < 1:
                pass
            else:
                decoup = line.split('=', 1)
                loadok = self.loadvar(decoup)
                if loadok:
                    count = count + 1
        filestream.close()
        self.numvarload = count

    def loadvar(self, descriptvar):
        if str(descriptvar[0]).find('Origin X') >=0:
            self.Ox = np.float64(descriptvar[1])
            self.varlist.append('Ox')
            return True
        if descriptvar[0].find('Origin Y') >= 0:
            self.Oy = np.float64(descriptvar[1])
            self.varlist.append('Oy')
            return True
        if descriptvar[0].find('Origin Z') >= 0:
            self.Oz = np.float64(descriptvar[1])
            self.varlist.append('Oz')
            return True
        if descriptvar[0].find('Lenght X') >= 0:
            self.Lx = np.float64(descriptvar[1])
            self.varlist.append('Lx')
            return True
        if descriptvar[0].find('Lenght Y') >= 0:
            self.Ly = np.float64(descriptvar[1])
            self.varlist.append('Ly')
            return True
        if descriptvar[0].find('Lenght Z') >= 0:
            self.Lz = np.float64(descriptvar[1])
            self.varlist.append('Lz')
            return True
        if descriptvar[0].find('Resolution X') >= 0:
            self.resX = np.float64(descriptvar[1])
            self.varlist.append('resX')
            return True
        if descriptvar[0].find('Resolution Y') >= 0:
            self.resY = np.float64(descriptvar[1])
            self.varlist.append('resY')
            return True
        if descriptvar[0].find('Resolution Z') >= 0:
            self.resZ = np.float64(descriptvar[1])
            self.varlist.append('resZ')
            return True
        if descriptvar[0].find('Time Step') >= 0:
            self.timeStep = np.float64(descriptvar[1])
            self.varlist.append('timeStep')
            return True
        if descriptvar[0].find('Final Time') >= 0:
            self.finalTime = np.float64(descriptvar[1])
            self.varlist.append('finalTime')
            return True
        if descriptvar[0].find('Restart') >= 0:
            self.restart = np.uint32(descriptvar[1])
            self.varlist.append('restart')
            return True
        if descriptvar[0].find('Frequency of Saving') >= 0:
            self.dumpfreq = np.uint32(descriptvar[1])
            self.varlist.append('dumpfreq')
            return True
        if descriptvar[0].find('File to restart') >= 0:
            self.dumpfile = descriptvar[1]
            self.varlist.append('dumpfile')
            return True
        if descriptvar[0].find('Frequency of Visualisation') >= 0:
            self.outModuloPrinter = np.uint32(descriptvar[1])
            self.varlist.append('outModuloPrinter')
            return True
        if descriptvar[0].find('Output file for visualisation') >= 0:
            self.outputPrinter = ''.join(descriptvar[1].rstrip('\n').split())
            self.varlist.append('outputPrinter')
            return True
        if descriptvar[0].find('Frequency of Forces output') >= 0:
            self.outModuloForces = np.uint32(descriptvar[1])
            self.varlist.append('outModuloForces')
            return True
        if descriptvar[0].find('Output file for Forces') >= 0:
            self.outputForces = ''.join(descriptvar[1].rstrip('\n').split())
            self.varlist.append('outputForces')
            return True
        if descriptvar[0].find('Frequency of Energy output') >= 0:
            self.outModuloEnergies = np.float64(descriptvar[1])
            self.varlist.append('outModuloEnergies')
            return True
        if descriptvar[0].find('Output file for Energy') >= 0:
            self.outputEnergies = ''.join(descriptvar[1].rstrip('\n').split())
            self.varlist.append('outputEnergies')
            return True
        if descriptvar[0].find('Upstream velocity') >= 0:
            self.uinf = np.float64(descriptvar[1])
            self.varlist.append('uinf')
            return True
        if descriptvar[0].find('Density') >= 0:
            self.rho = np.float64(descriptvar[1])
            self.varlist.append('rho')
            return True
        if descriptvar[0].find('Viscosity') >= 0:
            self.visco = np.float64(descriptvar[1])
            self.varlist.append('visco')
            return True
        if descriptvar[0].find('Dens2') >= 0:
            self.rho2 = np.float64(descriptvar[1])
            self.varlist.append('rho2')
            return True
        if descriptvar[0].find('Visco2') >= 0:
            self.visco2 = np.float64(descriptvar[1])
            self.varlist.append('visco2')
            return True
        if descriptvar[0].find('Advection Method') >= 0:
            self.methodAdv = descriptvar[1].rstrip('\n')
            self.varlist.append('methodAdv')
            return True
        if descriptvar[0].find('Scalar Advec Method') >= 0:
            self.methodAdvSc = descriptvar[1].rstrip('\n')
            self.varlist.append('methodAdvSc')
            return True
        if descriptvar[0].find('Stretching Method') >= 0:
            self.methodStretch = descriptvar[1].rstrip('\n')
            self.varlist.append('methodStretch')
            return True
        if descriptvar[0].find('Stretching Property') >= 0:
            self.propStretch = descriptvar[1].rstrip('\n')
            self.varlist.append('propStretch')
            return True
        if descriptvar[0].find('Baro Method') >= 0:
            self.methodBaro = descriptvar[1].rstrip('\n')
            self.varlist.append('methodBaro')
            return True
        if descriptvar[0].find('Penalisation Method') >= 0:
            self.methodPenal = descriptvar[1].rstrip('\n')
            self.varlist.append('methodPenal')
            return True
        if descriptvar[0].find('Forces Method') >= 0:
            self.methodForces = descriptvar[1].rstrip('\n')
            self.varlist.append('methodForces')
            return True
        if descriptvar[0].find('Vorticity projection') >= 0:
            self.vortProj = np.uint32(descriptvar[1])
            self.varlist.append('vortProj')
            return True
        if descriptvar[0].find('Multi resolution') >= 0:
            self.multires = np.uint32(descriptvar[1])
            self.varlist.append('multires')
            return True
        if descriptvar[0].find('Resolution Filter X') >= 0:
            self.resFilterX = np.uint32(descriptvar[1])
            self.varlist.append('resFilterX')
            return True
        if descriptvar[0].find('Resolution Filter Y') >= 0:
            self.resFilterY = np.uint32(descriptvar[1])
            self.varlist.append('resFilterY')
            return True
        if descriptvar[0].find('Resolution Filter Z') >= 0:
            self.resFilterZ = np.uint32(descriptvar[1])
            self.varlist.append('resFilterZ')
            return True
        if descriptvar[0].find('Name of Obstacle') >= 0:
            self.obstName = descriptvar[1].rstrip('\n')
            self.varlist.append('obstName')
            return True
        if descriptvar[0].find('Lambda Fluid') >= 0:
            self.lambdFluid = np.float64(descriptvar[1])
            self.varlist.append('lambdFluid')
            return True
        if descriptvar[0].find('Lambda Porous') >= 0:
            self.lambdPorous = np.float64(descriptvar[1])
            self.varlist.append('lambdPorous')
            return True
        if descriptvar[0].find('Lambda Solid') >= 0:
            self.lambdSolid = np.float64(descriptvar[1])
            self.varlist.append('lambdSolid')
            return True
        if descriptvar[0].find('Obstacle Radius') >= 0:
            self.obstRadius = np.float64(descriptvar[1])
            self.varlist.append('obstRadius')
            return True
        if descriptvar[0].find('Obstacle origin in X') >= 0:
            self.obstOx = np.float64(descriptvar[1])
            self.varlist.append('obstOx')
            return True
        if descriptvar[0].find('Obstacle origin in Y') >= 0:
            self.obstOy = np.float64(descriptvar[1])
            self.varlist.append('obstOy')
            return True
        if descriptvar[0].find('Obstacle origin in Z') >= 0:
            self.obstOz = np.float64(descriptvar[1])
            self.varlist.append('obstOz')
            return True
        if descriptvar[0].find('Thickness of Porous layer') >= 0:
            self.thicknPorous = np.float64(descriptvar[1])
            self.varlist.append('thicknPorous')
            return True
        if descriptvar[0].find('Size of Bound in Z direction') >= 0:
            self.thicknZ = np.float64(descriptvar[1])
            self.varlist.append('thicknZ')
            return True
        print 'The variable ' + str(descriptvar[0]) + 'is unknown.' +\
            'It\'s not load'
        return False

    def __str__(self):
        """
        Common printings for operators
        """
        s = str(self.filename) + " has " + str(self.numvarload) +\
            " variables loaded, list:" +\
            ','.join(str(x) for x in self.varlist)
        return s + "\n"

if __name__ == "__main__":
    print __doc__
    print "- Provided class : problem"
    print Problem.__doc__
