"""
@package parmepy.gpu
Everything concerning GPU in Parmes.

OpenCL sources are located in the cl_src directory and organized as follows
  - kernels/
  Contains kernels src
    - advection.cl
    - remeshing.cl
    - advection_and_remeshing.cl
    - rendering.cl
  Functions used by kernels
  - advection/
    - builtin.cl
    - builtin_noVec.cl
  - remeshing/
    - basic.cl
    - basic_noVec.cl
    - private.cl
    - weights.cl
    - weights_builtin.cl
    - weights_noVec.cl
    - weights_noVec_builtin.cl
  - common.cl

Sources are parsed at build to handle several OpenCL features
@see parmepy.gpu.tools.parse_file

"""
from parmepy.constants import np
import pyopencl
## open cl underlying implementation
cl = pyopencl

import os
## GPU deflault sources
GPU_SRC = os.path.join(__path__[0], "cl_src", '')
PARMES_REAL_GPU = np.float32
PARMES_DOUBLE_GPU = np.float64
PARMES_INTEGER_GPU = np.uint32

## If use OpenCL profiling events to time computations
CL_PROFILE = False

