## @package parmepy.operator
# Operators on continuous fields.
#
# An operator is an abstract object that handles a set of continuous variables
# and has an 'apply' function that modifies some of these variables.
#
# Example:
# To define and apply the advection of a scalar rho at velocity v:
#\code
# advec = parmepy.operator.advection(v, rho, ...)
# advec.setUp()
# ...
# advec.apply()
# \endcode
