"""
Testing parmepy.operator.synchronization
"""
import parmepy as pp
import numpy as np
from parmepy.operator.synchronizeGhosts import SynchronizeGhosts
from parmepy.fields.continuous import Field
from parmepy.mpi.topology import Cartesian
#from parmepy.fields.analytical import AnalyticalField
from parmepy.mpi.main_var import main_comm, main_size, main_rank, MPI
from parmepy.operator.analytic import Analytic
from parmepy.problem.simulation import Simulation

def computeVel(x, y, z):
    vx = x
    vy = y
    vz = z
    return vx, vy, vz


def test_Synchro():
    nb = 65
    dim = 3
    boxLength = [1., 1., 1.]
    boxMin = [0., 0., 0.]
    nbElem = [nb, nb, nb]
    nbGhosts = [2, 2, 2]
    dom = pp.Box(dim, length=boxLength, origin=boxMin)
    ## Fields

    field = Field(domain=dom, formula=computeVel, name='velocity', isVector=True)
#    velo = AnalyticalField(domain=dom, formula=computeVel,
#                           name='Velocity', isVector=True)
#    Synchrotest = SynchronizeGhosts(velo, resolution={velo: nbElem},
    Synchrotest = SynchronizeGhosts(field, resolution={field: nbElem},
                                    method='greaterSend')

    simu = Simulation(tinit=0., tend=1., timeStep=0.5)
    if main_rank ==0 :
        print "Setup Synchro"
    Synchrotest.setUp(nbGhosts)
    field.initialize()
    if main_rank ==0 :
        print "Apply Synchro"
    Synchrotest.apply(simu)

if __name__ == "__main__":
#    print "Rank", main_rank
    test_Synchro()
